Package org.optaplanner.core.impl.score.buildin.bendablebigdecimal

## Class BendableBigDecimalScoreDefinition

- java.lang.Object
- - org.optaplanner.core.impl.score.definition.AbstractScoreDefinition<Score_>
  - - org.optaplanner.core.impl.score.definition.AbstractBendableScoreDefinition<BendableBigDecimalScore>
    - - org.optaplanner.core.impl.score.buildin.bendablebigdecimal.BendableBigDecimalScoreDefinition

- All Implemented Interfaces:
    `ScoreDefinition<BendableBigDecimalScore>`

      public class BendableBigDecimalScoreDefinition
      extends AbstractBendableScoreDefinition<BendableBigDecimalScore>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.definition.AbstractBendableScoreDefinition

      `hardLevelsSize, softLevelsSize`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BendableBigDecimalScoreDefinition​(int hardLevelsSize, int softLevelsSize)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `BendableBigDecimalScore` | `buildOptimisticBound​(InitializingScoreTrend initializingScoreTrend, BendableBigDecimalScore score)` | Builds a `Score` which is equal or better than any other `Score` with more variables initialized (while the already variables don't change).
    `BendableBigDecimalScore` | `buildPessimisticBound​(InitializingScoreTrend initializingScoreTrend, BendableBigDecimalScore score)` | Builds a `Score` which is equal or worse than any other `Score` with more variables initialized (while the already variables don't change).
    `BendableBigDecimalScoreHolderImpl` | `buildScoreHolder​(boolean constraintMatchEnabled)` | Used by `DroolsScoreDirector`.
    `BendableBigDecimalScoreInliner` | `buildScoreInliner​(boolean constraintMatchEnabled)` | Used by `BavetConstraintFactory`
    `BendableBigDecimalScore` | `createScore​(BigDecimal... scores)` |
    `BendableBigDecimalScore` | `createScoreUninitialized​(int initScore, BigDecimal... scores)` |
    `BendableBigDecimalScore` | `divideBySanitizedDivisor​(BendableBigDecimalScore dividend, BendableBigDecimalScore divisor)` | Return `Score` whose every level is the result of dividing the matching levels in this and the divisor.
    `BendableBigDecimalScore` | `fromLevelNumbers​(int initScore, Number[] levelNumbers)` | The opposite of `Score.toLevelNumbers()`.
    `BendableBigDecimalScore` | `getOneSoftestScore()` | The score that represents the softest possible one.
    `Class<BendableBigDecimalScore>` | `getScoreClass()` | Returns the `Class` of the actual `Score` implementation.
    `BendableBigDecimalScore` | `getZeroScore()` | The score that represents zero.
    `BendableBigDecimalScore` | `parseScore​(String scoreString)` | Parses the `String` and returns a `Score`.

    - ### Methods inherited from class org.optaplanner.core.impl.score.definition.AbstractBendableScoreDefinition

      `generateLevelLabels, getFeasibleLevelsSize, getHardLevelsSize, getLevelsSize, getSoftLevelsSize, isCompatibleArithmeticArgument`

    - ### Methods inherited from class org.optaplanner.core.impl.score.definition.AbstractScoreDefinition

      `divide, divide, divide, divide, formatScore, getInitLabel, getLevelLabels, sanitize, sanitize, sanitize, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.definition.ScoreDefinition

      `formatScore, getInitLabel, getLevelLabels, isNegativeOrZero, isPositiveOrZero`

- - ### Constructor Detail

    - #### BendableBigDecimalScoreDefinition

          public BendableBigDecimalScoreDefinition​(int hardLevelsSize,
                                                   int softLevelsSize)

  - ### Method Detail

    - #### getScoreClass

          public Class<BendableBigDecimalScore> getScoreClass()

      Description copied from interface: `ScoreDefinition`
      Returns the `Class` of the actual `Score` implementation. For example: returns `HardSoftScore.class` on `HardSoftScoreDefinition`.
      Returns:
        never null

    - #### getZeroScore

          public BendableBigDecimalScore getZeroScore()

      Description copied from interface: `ScoreDefinition`
      The score that represents zero.
      Returns:
        never null

    - #### getOneSoftestScore

          public final BendableBigDecimalScore getOneSoftestScore()

      Description copied from interface: `ScoreDefinition`
      The score that represents the softest possible one.
      Returns:
        never null

    - #### parseScore

          public BendableBigDecimalScore parseScore​(String scoreString)

      Description copied from interface: `ScoreDefinition`
      Parses the `String` and returns a `Score`.
      Parameters:
        `scoreString` - never null
      Returns:
        never null
      See Also:
        `ScoreDefinition.formatScore(Score)`, `ScoreUtils.parseScore(Class, String)`

    - #### fromLevelNumbers

          public BendableBigDecimalScore fromLevelNumbers​(int initScore,
                                                          Number[] levelNumbers)

      Description copied from interface: `ScoreDefinition`
      The opposite of `Score.toLevelNumbers()`.
      Parameters:
        `initScore` - `<= 0`, managed by OptaPlanner, needed as a parameter in the `Score`'s creation method, see `Score.getInitScore()`
        `levelNumbers` - never null
      Returns:
        never null

    - #### createScore

          public BendableBigDecimalScore createScore​(BigDecimal... scores)

    - #### createScoreUninitialized

          public BendableBigDecimalScore createScoreUninitialized​(int initScore,
                                                                  BigDecimal... scores)

    - #### buildScoreInliner

          public BendableBigDecimalScoreInliner buildScoreInliner​(boolean constraintMatchEnabled)

      Description copied from interface: `ScoreDefinition`
      Used by `BavetConstraintFactory`
      Parameters:
        `constraintMatchEnabled` - true if `InnerScoreDirector.isConstraintMatchEnabled()` should be true
      Returns:
        never null

    - #### buildScoreHolder

          public BendableBigDecimalScoreHolderImpl buildScoreHolder​(boolean constraintMatchEnabled)

      Description copied from interface: `ScoreDefinition`
      Used by `DroolsScoreDirector`.
      Parameters:
        `constraintMatchEnabled` - true if`InnerScoreDirector.isConstraintMatchEnabled()` should be true
      Returns:
        never null

    - #### buildOptimisticBound

          public BendableBigDecimalScore buildOptimisticBound​(InitializingScoreTrend initializingScoreTrend,
                                                              BendableBigDecimalScore score)

      Description copied from interface: `ScoreDefinition`
      Builds a `Score` which is equal or better than any other `Score` with more variables initialized (while the already variables don't change).
      Parameters:
        `initializingScoreTrend` - never null, with `InitializingScoreTrend.getLevelsSize()` equal to `ScoreDefinition.getLevelsSize()`.
        `score` - never null, with `Score.getInitScore()` `0`.
      Returns:
        never null

    - #### buildPessimisticBound

          public BendableBigDecimalScore buildPessimisticBound​(InitializingScoreTrend initializingScoreTrend,
                                                               BendableBigDecimalScore score)

      Description copied from interface: `ScoreDefinition`
      Builds a `Score` which is equal or worse than any other `Score` with more variables initialized (while the already variables don't change).
      Parameters:
        `initializingScoreTrend` - never null, with `InitializingScoreTrend.getLevelsSize()` equal to `ScoreDefinition.getLevelsSize()`.
        `score` - never null, with `Score.getInitScore()` `0`
      Returns:
        never null

    - #### divideBySanitizedDivisor

          public BendableBigDecimalScore divideBySanitizedDivisor​(BendableBigDecimalScore dividend,
                                                                  BendableBigDecimalScore divisor)

      Description copied from interface: `ScoreDefinition`
      Return `Score` whose every level is the result of dividing the matching levels in this and the divisor. When rounding is needed, it is floored (as defined by `Math.floor(double)`).

      If any of the levels in the divisor are equal to zero, the method behaves as if they were equal to one instead.

        `divisor` - value by which this Score is to be divided
      Returns:
        this / divisor